> For the complete documentation index, see [llms.txt](https://docs.easy.gg/scripting/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.easy.gg/scripting/bedwars-scripting/objects/abilityconfig.md).

# AbilityConfig

### Parameters

#### maxProgress: number

The maximum amount of progress that can be stored on the ability.

#### progressPerUse: number

The amount of progress used every time the ability is activated.

#### iconImage: string | nil

An optional [rbxassetid](https://create.roblox.com/docs/projects/assets) of the image that will be shown on the button for the ability.

```lua
Events.UseAbility(function (event)
    if (event.abilityName == "yeehaw") then
        AnnouncementService.sendAnnouncement("YEEHAW!")
    end
end)

-- Create a "yeehaw" ability that is activated with the X key
-- The ability has 2 stacks of "yeehaw"
local abilityConfig = {
    maxProgress = 10, 
    progressPerUse = 5
    iconImage = "rbxassetid://7193644599"
}
AbilityService.createAbility("yeehaw", KeyCode.X, abilityConfig)

-- Add the ability to the host
AbilityService.enableAbility(MatchService.getHost(), "yeehaw")
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.easy.gg/scripting/bedwars-scripting/objects/abilityconfig.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
